<?php
/**
 * @subpackage Plugins
 * @license    GNU/GPL
 * $user->registerDate = date('Y-m-d H:i:s');
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
 
jimport('joomla.event.plugin');
 
/**
 * Conftool Authentication Plugin.  Based on the example.php plugin in the Joomla! Core installation
 *
 * @package    Joomla.Conftool
 * @subpackage Plugins
 * @license    GNU/GPL
 */
class plgAuthenticationAuth_ct extends JPlugin
{

	// Communicates a request to the ConfTool installation
	private function ConfToolQuery($command, $parameters)
	{	// Get parameters
  	    $server = $this->params->get('ctserver');
  	    $server_port = $this->params->get('ctport');
  	    $ssl = $this->params->get('ctssl');
  	    $path = $this->params->get('ctpath');
  	    $referer = $this->params->get('ctreferer');
  	    $password = $this->params->get('ctpassword');
  	    $method = $this->params->get('ctmethod');

		// Generate Hash
		$nonce = round(microtime(true)*1000);
		$passhash = hash("sha256",$nonce.$password);
		
		// Generate data
		$data = "page=remoteLogin";
		$data .= "&command=".urlencode(urldecode($command));
		$data .= "&passhash=".urlencode(urldecode($passhash));
		$data .= "&nonce=".urlencode(urldecode($nonce));
		if (count($parameters))
		{	foreach ($parameters as $key => $value)
			{	$data .= "&".$key."=".urlencode(urldecode($value));
			}
		}
		
		// Set protocol
		$host = $server;
		if ($ssl)
		{	$host = "ssl://".$host;
			if ($port == "")
			{	$port = 443;
			}
			$protocol = "HTTPS/1.1";
		}
		else if ($port == "")
		{	$port = 80;
			$protocol = "HTTP/1.1";
		}

		// Compose message content
		if ($method == "GET")
		{	$con = "GET ".$path."?".$data." ".$protocol."\r\n";
		}
		else
		{	$con = "POST ".$path." ".$protocol."\r\n";
		}
		$con = $con."Host: ".$server."\r\n";
		$con = $con."Referer: ".$referer."\r\n";
		$con = $con."Content-type: application/x-www-form-urlencoded\r\n";
		if ($method != "GET")
 		{	$con = $con."Content-length: ".strlen($data)."\r\n";
 		}
		$con = $con."Connection: close\r\n\r\n";

		// Send request
		$fp = @fsockopen($host, $port, $errno);
		if (is_resource($fp))
		{	fputs($fp,$con);
			if ($method != "GET")
			{	fputs($fp,$data);
			}
			$res = "";
			while(!feof($fp))
			{	$res .= fgets($fp, 128);
			}
			fclose($fp);
			// Parse HTTP response
			// this could be done a little bit more neatly to identify errors...
			$res = $this -> parse_http_response($res);
			return $res[1];
		}
		return false;
	}

	// Parse HTTP response adapted from http://snipplr.com/view/17242/
    private function parse_http_response($string)
    {
        $headers = array();
    	$content = '';
    	$str = strtok($string, "\n");
    	$h = null;
    	while ($str !== false) 
    	{	if ($h and trim($str) === '') 
    		{	$h = false;
			    continue;
		    }
		    if ($h !== false and false !== strpos($str, ':')) 
		    {	$h = true;
			    list($headername, $headervalue) = explode(':', trim($str), 2);
			    $headername = strtolower($headername);
			    $headervalue = ltrim($headervalue);
			    if (isset($headers[$headername]))
				    $headers[$headername] .= ',' . $headervalue;
			    else
			    $headers[$headername] = $headervalue;
		    }
		    if ($h === false) 
		    {    $content .= $str."\n";
    		}
		    $str = strtok("\n");
   		}
		return array($headers, trim($content));
    }



    /**
     * Constructor
     *
     * For php4 compatability we must not use the __constructor as a constructor for plugins
     * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
     * This causes problems with cross-referencing necessary for the observer design pattern.
     *
     * @param object $subject The object to observe
     * @since 1.5
     */
    function plgAuthenticationAuth_ct(& $subject, $params) {
        parent::__construct($subject, $params);
    }
 
	/* Custom event method */ 
 	public function onUserAuthenticateImport(&$r)
	{	$command = $r;
		$result = "";
		if ($command == "undo")
		{	$igroup = $this->params->get('ctimportgroup');
			if ($igroup != "")
			{	echo "<h2>Deleting last imported users.</h2>\r\n";
				jimport( 'joomla.access.access' );
				$oldusers = JAccess::getUsersByGroup($igroup);
				if (count($oldusers) > 0)
				{	echo "<ul>";
					jimport( 'joomla.user.user' );
					foreach($oldusers as $u)
					{	$uo1 =& JFactory::getUser($u);
						echo "<li>Deleting user ID ".$u." with username ".$uo1 -> username.".</li>\r\n";
						$uo1 -> delete();
					}
					echo "</ul>";
				}
				else
				{	echo "<p>No users do delete.</p>\r\n";
				}
			}
			else
			{	echo "<p>Undo not possible. Please set bulk import group in backend.</p>\r\n";
			}
			return true;
		}
		$folder = JPATH_ROOT . "/tmp/auth_ct";
		// Get time limitations
		$maxphptime = (integer)($this->params->get('ctimportmaxtime'));
		// Timing data;
		$starttime = microtime(true);
		$endtime = $starttime + $maxphptime;
		// See if process was already started
		$input = new JInput;
		$nr = (integer)($input->get('startuser', '', 'get'));
		$set = $input->get('set', '', 'get');
		$file = "ctai_".hash("sha256",$set);


		if ($set != "" && !(file_exists($folder."/".$file)))
		{	echo "Temporary file not found, please clean up last import and restart import.<br />";
			return false;
		}
		else if ($set == "")
		{	// Start with first user in new file
			$nr = 0;
			// Retrieve file and save locally
			$set = round(microtime(true)*1000);
			$file = "ctai_".hash("sha256",$set);
			if (!(file_exists($folder)))
			{	mkdir($folder);
				if (!(file_exists($folder)))
				{	echo "Could not create folder for temporary file.";
					return false;
				}
				else
				{	echo "Created folder for temporary file.<br />";
				}
			}
			// Secure data
			if ($fp = fopen($folder."/.htaccess","w"))
			{	fwrite($fp,"deny from all");
				fclose($fp);
			}
			else
			{	echo "Could not create .htaccess to secure data!<br />";
			}
			// Do ConfTool Request
			$res = $this -> ConfToolQuery("export",array());
			// save ConfTool file
			$fp = fopen($folder."/".$file,"w");
			if ($fp)
			{	fwrite($fp,$res);
				fclose($fp);
				echo "Created temporary file.<br />";
			}
			else
			{	echo "Could not create temporary file.<br />";
			}
		}
		else
		{	$res = file_get_contents($folder."/".$file);
			// Startnummer notfalls zurücksetzen
			if (!$nr)
			{	$nr=0;
			}
			echo "Using stored data file.";
		}

		// Process XML
		$res = simplexml_load_string($res);
		// Set maximum execution time (does not help anyway)
		// ini_set('max_execution_time', 300);
		
		echo "<p>\r\n";
		if ($res instanceof SimpleXMLElement)
		{	$usercount = count($res -> user);
			echo "<h2>Importing User Information</h2>\r\n";
			echo "<ul>\r\n";
			while (microtime(true) < $endtime && $nr < $usercount)
			{	$user = $res->user[$nr++];
				$uo = clone(JFactory::getUser(0));
				$rtext = "";
				if ($this -> process_user($uo,$user,true,$command,$rtext))
				{	echo "<li>Conftool-ID ".$user -> personID.": User ".$user -> username.", User-ID ".$uo -> id.", Name ".$user -> name.": ".$rtext."</li>\r\n";
				}
				else
				{	echo "<li>Conftool-ID ".$user -> personID.":  Dropped user ".$user -> username.". ".$rtext."</li>\r\n";
				}
			}
			echo "</ul>\r\n";
			// Are users left over?
			if ($nr < $usercount-1)
			{	echo "	<script>
							window.location.href='".JURI::current()."?startuser=".$nr."&set=".$set."&cti_command=".$command."';
						</script>";
			}
			else
			{	unlink($folder."/".$file);
				if (file_exists($folder."/".$file))
				{	echo "Could not remove temporary file, please clean up manually.<br/>\r\n";
				}
				echo "<br /><br />Import finished.<br/>\r\n";
			}
		}
		else
		{	echo "Could not process Conftool export file.\r\n";
		}
		echo "</p>";

		return true;
	}

    /**
     * This method should handle any authentication and report back to the subject
     * This example uses simple authentication - it checks if the password is the reverse
     * of the username (and the user exists in the database).
     *
     * @access    public
     * @param     string    $credentials Credentials for authentication
     * @param     string    $options     Options for authentication
     * @param     object    $response    Authentication response object
     * @return    boolean
     * @since 1.5
     */
    function onUserAuthenticate( $credentials, $options, &$response )
    {

		// Compose parameters for authentication request
		$parameters = array("user" => $credentials["username"], "password" => $credentials["password"]);
		// Do ConfTool Request
		$res = $this -> ConfToolQuery("login",$parameters);
		// Process XML
		$res = simplexml_load_string($res);

		if ($res instanceof SimpleXMLElement)
		{	// Get XML data
			$ct_userid = (string)$res -> id;
			$ct_username = trim($res -> username);
			$ct_valid = $res -> result;
			// Valid credentials?
			if ($ct_valid == "true")
			{	// obtain more information on the user
				// Compose parameters for authentication request
				$parameters = array("user" => $ct_username);
				// Do ConfTool Request via GET
				$user_status = $this -> ConfToolQuery("request",$parameters);
$xmltext = $user_status;
				// Process XML
				$user_status = simplexml_load_string($user_status);
				if ($user_status instanceof SimpleXMLElement)
				{	$user = JFactory::getUser(0);
					// process user information and add/update user in JOOMLA
					$r = $this -> process_user($user,$user_status -> user[0],false,$rtext);
					if ($r)
					{	$fullname = "";
						if ($user_status -> user[0] -> firstname != "")
							$fullname .= " ".$user_status -> user[0] -> firstname;
						if ($user_status -> user[0] -> name != "")
							$fullname .= " ".$user_status -> user[0] -> name;
						$email = (string) $user_status -> user -> email;
						// compose response
						$response->email = $email;
						$response->username = $ct_username;
						$response->fullname = $fullname;
						$response->status = JAUTHENTICATE_STATUS_SUCCESS;
						$response->error_message = '';
						$response->type = 'conftool';
						return $response;
					}
					else
					{	$response->status = JAUTHENTICATE_STATUS_FAILURE;
						$response->error_message = $rtext;
///			JFactory::getApplication()->enqueueMessage( " Message: ".$xmltext."-".$rtext);
						return $response;
					}
				}
			}
		}
		// Invalid user or other error
		$response->status = JAUTHENTICATE_STATUS_FAILURE;
		$response->error_message = 'Invalid username and password or authentication error.';
		if ($res -> message != "")
		{	JFactory::getApplication()->enqueueMessage( " Message: ".$res -> message);
		}
		return $response;
    }
    
    private function idmatches($id,$match)
    {	$match = explode(",",$match);
    	foreach ($match as $m)
    	{	$m = explode("-",$m);
    		if (count($m) == 1 && $m[0] == $id)
    		{	return true;
    		}
    		else if (count($m) == 2)
    		{	if ($id >= $m[0] && $id <= $m[1])
    			{	return true;
    			}
    		}
    	}
    	return false;
    }
    
    private function process_user(&$user,$user_status,$isbulkimport,$command,&$r)
    {	$r = "";
    	// get data
		$ct_userid = (integer)$user_status -> personID;
		$ct_username = trim($user_status -> username);
		if ($this -> idmatches($ct_userid,(string)($this->params->get('ctimportexcludeids'))))
		{	$r = "Remote login and import of excluded user not possible";
			return false;
		}
		if ($ct_userid == 1)
		{	$r = "Remote login and import of Conftool default admin user not possible";
			return false;
		}

		$fullname = "";
		if ($user_status  -> firstname != "")
			$fullname .= " ".$user_status  -> firstname;
		if ($user_status ->  name != "")
			$fullname .= " ".$user_status  -> name;
		$email = (string) $user_status -> email;

		// determine user id
		$db = jfactory::getdbo();
		$query = $db->getquery(true);
		$query	->select('id')
				->from('#__users')
				->where("username = '". $ct_username . "'" );       
		$db->setquery($query);

		// Request not successfull?
		if (!$db->query()) 
		{	$this->seterror($this->_db->geterrormsg());
			$r = "Error in database query.";
			return false;
		}
		$userid = $db->loadResult();

		if (!$userid)
		{
//			$user = &JFactory::getUser(0);
			if (!$isbulkimport || $command == "all" || ($command == "onlyfullmembers" &&  $this -> check_rule($user_status, array(), $this->params->get('ctoptions1'), $this->params->get('ctcheckbalance1'), $this->params->get('ctonlyifnot1'))))
			{	$userdata['name'] = $fullname;
				$userdata['email'] = $email;
				$userdata['groups'] = array($this->params->get('ctdefaultgroup'));
				$userdata['username'] = $ct_username;
				$userdata['sendEmail'] = 1;
				$userdata['block'] = 0;
	//			$userdata['Conftool-UID'] = $ct_userid;
				// bind data to user
				$r = "Adding user.";
				if (!$user->bind($userdata))
				{	$r .= " Binding data: ".JText::_( $user->getError()); // something went wrong!!
				}
			}
			else
			{	if ($command == "onlyfullmembers")
				{	$r = "User does not satisfy rule #1.";
				}
				else
				{	$r = "Not registered in JOOMLA system.";
				}
				return false;
			}
			$newuser = true;
		}
		else	// Valid User ID: User is already registered
		{	// Otherwise get User
			$user = &JFactory::getUser($userid);
			// Ensure the registered user is exactly the same and was imported from Conftool
			// Does not work at the moment!
//			if ($user -> getParam("Conftool-UID") != $ct_userid)
//			{	$r = 'Conftool user ID does not match existing user information.';
//				return false;
//			}
			$r = "Updating user information.";
			$newuser = false;
		}
		// Adapt user data
		// set groups by rules
		$user = $this -> set_user_groups($user, $user_status);

		// set bulk import group if new user on bulk import
		$igroup = $this->params->get('ctimportgroup');
		if ($newuser && $isbulkimport && $igroup != "")
		{	$ugroups = $user -> get('groups');
			$ugroups[$igroup] = $igroup;
			if (!($user -> set('groups', $ugroups)))
			{	$r .= " Setting groups: ".JText::_( $user->getError()); // something went wrong!!
				return false;
			}
		} 
		// remove bulk import group if this is not an import
		else if (!$isbulkimport && $igroup != "")
		{	$ugroups = $user -> get('groups');
			unset($ugroups[$igroup]);
			$user -> set('groups', $ugroups);
		}
		// Save changes on the user
		if (!$user->save())
		{	$r .= " Saving user: ".JText::_( $user->getError()); // something went wrong!!
			return false;
		}
		return true;
	}
	private function set_user_groups($user, $status)
	{	$changed = false;
		$changed = $this->check_groups($user,$status,$this->params->get('ctoptions1'),$this->params->get('ctgroup1'),$this->params->get('ctdelgroup1'),$this->params->get('ctonlyifnot1'),$this->params->get('ctcheckbalance1'));
		if (!$changed)
		{	$changed = $this->check_groups($user,$status,$this->params->get('ctoptions2'),$this->params->get('ctgroup2'),$this->params->get('ctdelgroup2'),$this->params->get('ctonlyifnot2'),$this->params->get('ctcheckbalance2'));
		}
		if (!$changed)
		{	$changed = $this->check_groups($user,$status,$this->params->get('ctoptions3'),$this->params->get('ctgroup3'),$this->params->get('ctdelgroup3'),$this->params->get('ctonlyifnot3'),$this->params->get('ctcheckbalance3'));
		}
		if (!$changed)
		{	$changed = $this->check_groups($user,$status,$this->params->get('ctoptions4'),$this->params->get('ctgroup4'),$this->params->get('ctdelgroup4'),$this->params->get('ctonlyifnot4'),$this->params->get('ctcheckbalance4'));
		}
		return $user;
	}

	private function check_groups(&$user,$status,$options,$group,$delgroup,$nongroup,$checkbalance)
	{
//		JFactory::getApplication()->enqueueMessage( "output:".print_r($options,true)."XXX".$group);
		$options = trim($options);
		
		if ($options == "") // Empty --> do nothing
		{	return false;
		}
		$ugroups = $user -> get('groups');
		if ($this -> check_rule($status, $ugroups, $options, $checkbalance, $nongroup))
		{	if ($group != "")
			{	$ugroups[$group] = $group;
			}
			if ($delgroup != "")
			{	unset($ugroups[$delgroup]);
			}
			$user -> set('groups', $ugroups);
			return true;
		}
		return false;
	}
	
	private function check_rule($status, $ugroups, $options, $checkbalance, $nongroup)
	{	// Check if the rule applies to the user
		$part_status = (string)($status -> participant_status);
		$part_amount = (integer)($status -> participant_amount_open);
		if ($options == "*")	// Wildcard?
		{	if (($checkbalance == 0 || $part_amount == 0) && ($nongroup == "" || array_search($nongroup,$ugroups) != $nongroup))
			{	return true;
			}
		}
		else	// Else search for option
		{	$options = explode(";",$options);
			foreach ($options as $o)
			{	if ($o == $part_status)
				{	if (($checkbalance == 0 || $part_amount == 0) && ($nongroup == "" || array_search($nongroup,$ugroups) != $nongroup))
					{	return true;
					}
				}
			}
		}
		return false;
	}   
}
////		JFactory::getApplication()->enqueueMessage( "***End -");

?>
